﻿Imports System.Threading

Public Delegate Sub TrickAction()

Public MustInherit Class CircusAnimal
#Region " Properties "
    Public Property Legs As Integer
    Public Property LegsOnGround() As Integer
    Public Property TricksDone() As Integer
    Public Property IncentivesGiven() As Integer
    Protected Sound As String
#End Region

#Region " Delegates "
    Public Sub Speak()
        Console.WriteLine(Sound)
        TricksDone += 1
    End Sub

    Public Shared Sub WatchOthers()
        Console.WriteLine("Watching is boring")
    End Sub

    Public Sub Stand()
        If LegsOnGround = 4 Then
            LegsOnGround -= 2
        End If
        Console.WriteLine("Legs on Ground = {0}", LegsOnGround)
        TricksDone += 1
    End Sub

    Public Sub DoTrick(ByVal trick As TrickAction)
        If TricksDone <= IncentivesGiven Then
            trick.Invoke()
        Else
            Console.WriteLine("Need an incentive")
        End If
        RaiseEvent RequestIncentive(Me, Nothing)
    End Sub

    Public Sub DoTrick(ByVal trick As TrickAction, ByVal incentivesGiven As Integer)
        Me.IncentivesGiven += incentivesGiven
        DoTrick(trick)
    End Sub

    Public Sub BeginTrick(ByVal trick As TrickAction)
        trick.BeginInvoke(Sub(result) 
                              Thread.Sleep(1000)
                              Console.WriteLine("...Trick Completed for " & ToString())
                          End Sub , Me)
    End Sub

    Public Event RequestIncentive(ByVal sender As CircusAnimal, ByVal e As EventArgs)

    Public TrickList As New List(Of TrickAction)

    Public Sub DoTricks()
        TrickList.AsParallel.ForAll(Sub(trick) trick.Invoke)
    End Sub
#End Region

#Region " Business Rules "
    Private ValidationRules As New List(Of Predicate(Of CircusAnimal)) From {
                    Function(animal As CircusAnimal) animal.legsonground <= animal.legs,
                    Function(animal As CircusAnimal) animal.Legs <= 4
            }

    Public Function IsValid()
        Return ValidationRules.Where(Function(rule) Not rule(Me)).FirstOrDefault Is Nothing
    End Function
#End Region
End Class
